//////////////////////////////////////////////////////////////////////////////
// Filename:          C:\suzaku\suzaku-s-20060710/drivers/opb_sil00h_v1_00_a/src/opb_sil00h.h
// Version:           1.00.a
// Description:       opb_sil00h Driver Header File
// Date:              Wed Jul 05 12:15:08 2006 (by Create and Import Peripheral Wizard)
//////////////////////////////////////////////////////////////////////////////

#ifndef OPB_SIL00H_H
#define OPB_SIL00H_H

/***************************** Include Files *******************************/

#include "xbasic_types.h"
#include "xstatus.h"
#include "xio.h"

/************************** Constant Definitions ***************************/


/**
 * User Logic Slave Space Offsets
 * -- SLAVE_REG0 : user logic slave module register 0
 * -- SLAVE_REG1 : user logic slave module register 1
 * -- SLAVE_REG2 : user logic slave module register 2
 * -- SLAVE_REG3 : user logic slave module register 3
 * -- SLAVE_REG4 : user logic slave module register 4
 * -- SLAVE_REG5 : user logic slave module register 5
 */
#define OPB_SIL00H_USER_SLAVE_SPACE_OFFSET (0x00000000)
#define OPB_SIL00H_SLAVE_REG0_OFFSET (OPB_SIL00H_USER_SLAVE_SPACE_OFFSET + 0x00000000)
#define OPB_SIL00H_SLAVE_REG1_OFFSET (OPB_SIL00H_USER_SLAVE_SPACE_OFFSET + 0x00000001)
#define OPB_SIL00H_SLAVE_REG2_OFFSET (OPB_SIL00H_USER_SLAVE_SPACE_OFFSET + 0x00000002)
#define OPB_SIL00H_SLAVE_REG3_OFFSET (OPB_SIL00H_USER_SLAVE_SPACE_OFFSET + 0x00000003)
#define OPB_SIL00H_SLAVE_REG4_OFFSET (OPB_SIL00H_USER_SLAVE_SPACE_OFFSET + 0x00000004)
#define OPB_SIL00H_SLAVE_REG5_OFFSET (OPB_SIL00H_USER_SLAVE_SPACE_OFFSET + 0x00000005)

/***************** Macros (Inline Functions) Definitions *******************/

/**
 *
 * Write a value to a OPB_SIL00H register. A 32 bit write is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is written.
 *
 * @param   BaseAddress is the base address of the OPB_SIL00H device.
 * @param   RegOffset is the register offset from the base to write to.
 * @param   Data is the data written to the register.
 *
 * @return  None.
 *
 * @note    None.
 *
 * C-style signature:
 * 	void OPB_SIL00H_mWriteReg(Xuint32 BaseAddress, unsigned RegOffset, Xuint32 Data)
 *
 */
#define OPB_SIL00H_mWriteReg(BaseAddress, RegOffset, Data) \
 	XIo_Out32((BaseAddress) + (RegOffset), (Xuint32)(Data))

/**
 *
 * Read a value from a OPB_SIL00H register. A 32 bit read is performed.
 * If the component is implemented in a smaller width, only the least
 * significant data is read from the register. The most significant data
 * will be read as 0.
 *
 * @param   BaseAddress is the base address of the OPB_SIL00H device.
 * @param   RegOffset is the register offset from the base to write to.
 *
 * @return  Data is the data from the register.
 *
 * @note    None.
 *
 * C-style signature:
 * 	Xuint32 OPB_SIL00H_mReadReg(Xuint32 BaseAddress, unsigned RegOffset)
 *
 */
#define OPB_SIL00H_mReadReg(BaseAddress, RegOffset) \
 	XIo_In32((BaseAddress) + (RegOffset))


/**
 *
 * Write/Read value to/from OPB_SIL00H user logic slave registers.
 *
 * @param   BaseAddress is the base address of the OPB_SIL00H device.
 * @param   Value is the data written to the register.
 *
 * @return  Data is the data from the user logic slave register.
 *
 * @note    None.
 *
 * C-style signature:
 * 	Xuint8 OPB_SIL00H_mReadSlaveRegn(Xuint32 BaseAddress)
 *
 */
#define OPB_SIL00H_mWriteSlaveReg0(BaseAddress, Value) \
 	XIo_Out8((BaseAddress) + (OPB_SIL00H_SLAVE_REG0_OFFSET), (Xuint8)(Value))
#define OPB_SIL00H_mWriteSlaveReg1(BaseAddress, Value) \
 	XIo_Out8((BaseAddress) + (OPB_SIL00H_SLAVE_REG1_OFFSET), (Xuint8)(Value))
#define OPB_SIL00H_mWriteSlaveReg2(BaseAddress, Value) \
 	XIo_Out8((BaseAddress) + (OPB_SIL00H_SLAVE_REG2_OFFSET), (Xuint8)(Value))
#define OPB_SIL00H_mWriteSlaveReg3(BaseAddress, Value) \
 	XIo_Out8((BaseAddress) + (OPB_SIL00H_SLAVE_REG3_OFFSET), (Xuint8)(Value))
#define OPB_SIL00H_mWriteSlaveReg4(BaseAddress, Value) \
 	XIo_Out8((BaseAddress) + (OPB_SIL00H_SLAVE_REG4_OFFSET), (Xuint8)(Value))
#define OPB_SIL00H_mWriteSlaveReg5(BaseAddress, Value) \
 	XIo_Out8((BaseAddress) + (OPB_SIL00H_SLAVE_REG5_OFFSET), (Xuint8)(Value))

#define OPB_SIL00H_mReadSlaveReg0(BaseAddress) \
 	XIo_In8((BaseAddress) + (OPB_SIL00H_SLAVE_REG0_OFFSET))
#define OPB_SIL00H_mReadSlaveReg1(BaseAddress) \
 	XIo_In8((BaseAddress) + (OPB_SIL00H_SLAVE_REG1_OFFSET))
#define OPB_SIL00H_mReadSlaveReg2(BaseAddress) \
 	XIo_In8((BaseAddress) + (OPB_SIL00H_SLAVE_REG2_OFFSET))
#define OPB_SIL00H_mReadSlaveReg3(BaseAddress) \
 	XIo_In8((BaseAddress) + (OPB_SIL00H_SLAVE_REG3_OFFSET))
#define OPB_SIL00H_mReadSlaveReg4(BaseAddress) \
 	XIo_In8((BaseAddress) + (OPB_SIL00H_SLAVE_REG4_OFFSET))
#define OPB_SIL00H_mReadSlaveReg5(BaseAddress) \
 	XIo_In8((BaseAddress) + (OPB_SIL00H_SLAVE_REG5_OFFSET))

/************************** Function Prototypes ****************************/


/**
 *
 * Run a self-test on the driver/device. Note this may be a destructive test if
 * resets of the device are performed.
 *
 * If the hardware system is not built correctly, this function may never
 * return to the caller.
 *
 * @param   baseaddr_p is the base address of the OPB_SIL00H instance to be worked on.
 *
 * @return
 *
 *    - XST_SUCCESS   if all self-test code passed
 *    - XST_FAILURE   if any self-test code failed
 *
 * @note    Caching must be turned off for this function to work.
 * @note    Self test may fail if data memory and device are not on the same bus.
 *
 */
XStatus OPB_SIL00H_SelfTest(void * baseaddr_p);

#endif // OPB_SIL00H_H
